cookutils annotate cook @ rev 162

Add option to recompress source in LZMA
author Christophe Lincoln <pankso@slitaz.org>
date Sun May 15 00:19:54 2011 +0200 (2011-05-15)
parents 6f2181852647
children 18a92a268c5c
rev   line source
pankso@1 1 #!/bin/sh
pankso@1 2 #
pankso@1 3 # Cook - A tool to cook and generate SliTaz packages. Read the README
pankso@1 4 # before adding or modifing any code in cook!
pankso@1 5 #
pankso@1 6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
pankso@1 7 # Author: Christophe Lincoln <pankso@slitaz.org>
pankso@1 8 #
pankso@1 9
pankso@1 10 [ -f "/etc/slitaz/cook.conf" ] && . /etc/slitaz/cook.conf
pankso@1 11 [ -f "cook.conf" ] && . ./cook.conf
pankso@1 12
pankso@16 13 # Share DB and status with the Cooker.
pankso@9 14 activity="$CACHE/activity"
pankso@16 15 command="$CACHE/command"
pankso@11 16 broken="$CACHE/broken"
pankso@47 17 blocked="$CACHE/blocked"
pankso@9 18
pankso@1 19 #
pankso@1 20 # Functions
pankso@1 21 #
pankso@1 22
pankso@1 23 usage() {
pankso@1 24 cat << EOT
pankso@1 25
pankso@147 26 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command] [list|--option]
pankso@1 27
pankso@1 28 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
pankso@1 29 usage|help $(gettext "Display this short usage.")
pankso@1 30 setup $(gettext "Setup your build environment.")
pankso@9 31 test $(gettext "Test environment and cook a package.")
pankso@69 32 list-wok $(gettext "List packages in the wok.")
pankso@69 33 search $(gettext "Simple packages search function.")
paul@62 34 new $(gettext "Create a new package with a receipt".)
pankso@1 35 list $(gettext "Cook a list of packages.")
pankso@1 36 clean-wok $(gettext "Clean-up all packages files.")
paul@62 37 clean-src $(gettext "Clean-up all packages sources.")
pankso@1 38 pkglist $(gettext "Create all packages.* lists.")
pankso@1 39
pankso@1 40 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
pankso@10 41 --clean|-c Cook : $(gettext "clean the package in the wok.")
pankso@39 42 --install|-i Cook : $(gettext "cook and install the package.")
pankso@39 43 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
pankso@49 44 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
pankso@49 45 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
pankso@10 46 --wok|-w Setup: $(gettext "create also a wok from Hg repo.")
pankso@1 47
pankso@1 48 EOT
pankso@1 49 exit 0
pankso@1 50 }
pankso@1 51
paul@62 52 # Be sure we're root.
pankso@1 53 check_root() {
pankso@1 54 [ $(id -u) != 0 ] && gettext -e "\nYou must be root to cook.\n\n" && exit 0
pankso@1 55 }
pankso@1 56
pankso@1 57 separator() {
pankso@1 58 echo "================================================================================"
pankso@1 59 }
pankso@1 60
pankso@1 61 status() {
pankso@1 62 echo -en "\\033[70G[ "
pankso@1 63 if [ $? = 0 ]; then
pankso@1 64 echo -en "\\033[1;32mOK"
pankso@1 65 else
pankso@1 66 echo -en "\\033[1;31mFailed"
pankso@1 67 fi
pankso@1 68 echo -e "\\033[0;39m ]"
pankso@1 69 }
pankso@1 70
pankso@13 71 # Log activities, we want first letter capitalized.
pankso@9 72 log() {
pankso@27 73 grep ^[A-Z] | \
pankso@9 74 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
pankso@9 75 }
pankso@9 76
paul@62 77 # We don't want these escapes in web interface.
pankso@1 78 clean_log() {
pankso@1 79 sed -i -e s'|\[70G\[ \[1;32m| |' \
pankso@1 80 -e s'|\[0;39m \]||' $LOGS/$pkg.log
pankso@1 81 }
pankso@1 82
pankso@23 83 # Log broken packages.
pankso@23 84 broken() {
pankso@74 85 if ! grep -q "^$pkg$" $broken; then
pankso@74 86 echo "$pkg" >> $broken
pankso@74 87 fi
pankso@23 88 }
pankso@23 89
paul@62 90 # Be sure package exists in wok.
pankso@1 91 check_pkg_in_wok() {
pankso@1 92 if [ ! -d "$WOK/$pkg" ]; then
pankso@1 93 gettext -e "\nUnable to find package in the wok:"
pankso@1 94 echo -e " $pkg\n" && exit 1
pankso@1 95 fi
pankso@1 96 }
pankso@1 97
pankso@9 98 if_empty_value() {
pankso@9 99 if [ -z "$value" ]; then
pankso@9 100 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
pankso@9 101 exit 1
pankso@9 102 fi
pankso@9 103 }
pankso@9 104
paul@62 105 # Initialize files used in $CACHE
pankso@52 106 init_db_files() {
pankso@52 107 gettext "Creating directories structure in:"; echo " $SLITAZ"
pankso@52 108 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
pankso@52 109 gettext "Creating DB files in:"; echo " $CACHE"
pankso@52 110 for f in $activity $command $broken $blocked
pankso@52 111 do
pankso@52 112 touch $f
pankso@52 113 done
pankso@52 114 }
pankso@52 115
paul@62 116 # QA: check a receipt consistency before building.
pankso@9 117 receipt_quality() {
pankso@9 118 gettext -e "QA: checking package receipt...\n"
pankso@9 119 unset online
pankso@9 120 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
pankso@9 121 online="online"
pankso@9 122 fi
pankso@9 123 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
pankso@9 124 do
pankso@9 125 unset value
pankso@44 126 value=$(grep ^$var= $receipt | cut -d \" -f 2)
pankso@9 127 case "$var" in
pankso@9 128 PACKAGE|VERSION|SHORT_DESC)
pankso@9 129 if_empty_value ;;
pankso@9 130 CATEGORY)
pankso@9 131 [ -z "$value" ] && value="empty"
pankso@9 132 valid="base-system x-window utilities network graphics \
pankso@9 133 multimedia office development system-tools security games \
pankso@9 134 misc meta non-free"
pankso@9 135 if ! echo "$valid" | grep -q -w "$value"; then
paul@62 136 gettext "QA: unknown category:"; echo -e " $value\n"
pankso@9 137 exit 1
pankso@9 138 fi ;;
pankso@9 139 WEB_SITE)
paul@62 140 # We don't check WGET_URL since if dl is needed it will fail.
paul@62 141 # Break also if we're not online. Here error is not fatal.
pankso@9 142 if_empty_value
pankso@9 143 [ -z "$online" ] || break
pankso@9 144 if ! busybox wget -s $value 2>/dev/null; then
pankso@61 145 gettext "QA: Unable to reach:"; echo -e " $value"
pankso@9 146 fi ;;
pankso@9 147 esac
pankso@9 148 done
pankso@9 149 }
pankso@9 150
pankso@9 151 # Executed before sourcing a receipt.
pankso@9 152 unset_receipt() {
pankso@9 153 unset DEPENDS BUILD_DEPENDS WANTED EXTRAVERSION WGET_URL PROVIDE TARBALL
pankso@9 154 }
pankso@9 155
paul@62 156 # Paths used in receipt and by cook itself.
pankso@1 157 set_paths() {
pankso@1 158 pkgdir=$WOK/$PACKAGE
pankso@1 159 src=$pkgdir/source/$PACKAGE-$VERSION
pankso@44 160 taz=$pkgdir/taz
pankso@44 161 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
pankso@1 162 fs=$pack/fs
pankso@1 163 stuff=$pkgdir/stuff
pankso@1 164 install=$pkgdir/install
pankso@1 165 if [ "$WANTED" ]; then
pankso@1 166 src=$WOK/$WANTED/source/$WANTED-$VERSION
pankso@1 167 install=$WOK/$WANTED/install
pankso@121 168 wanted_stuff=$WOK/$WANTED/stuff
pankso@1 169 fi
pankso@9 170 # Old way compatibility.
pankso@1 171 _pkg=$install
pankso@1 172 }
pankso@1 173
pankso@144 174 # Create source tarball when URL is a SCM.
pankso@144 175 create_tarball() {
pankso@144 176 gettext "Creating tarball: "; echo "$tarball"
pankso@162 177 if [ "$LZMA_SRC" ]; then
pankso@162 178 tar -c $pkgsrc | lzma e $SRC/$tarball -si || exit 1
pankso@162 179 else
pankso@162 180 tar cjf $tarball $pkgsrc || exit 1
pankso@162 181 mv $tarball $SRC && rm -rf $pkgsrc
pankso@162 182 fi
pankso@144 183 }
pankso@144 184
pankso@145 185 # Get package source. For SCM we are in cache so clone here and create a
pankso@145 186 # tarball here.
pankso@1 187 get_source() {
pankso@115 188 pwd=$(pwd)
pankso@144 189 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
pankso@144 190 tarball=$pkgsrc.tar.bz2
pankso@162 191 [ "$LZMA_SRC" ] && tarball=$pkgsrc.tar.lzma
pankso@9 192 case "$WGET_URL" in
pankso@145 193 http://*|ftp://*)
pankso@9 194 # Busybox Wget is better!
pankso@145 195 busybox wget -c -P $SRC $WGET_URL || \
pankso@145 196 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
pankso@145 197 https://*)
pankso@145 198 wget -c --no-check-certificate -P $SRC $WGET_URL || \
pankso@15 199 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
pankso@9 200 hg*|mercurial*)
pankso@29 201 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
pankso@9 202 url=${WGET_URL#hg|}
pankso@9 203 else
pankso@9 204 url=${WGET_URL#mercurial|}
pankso@9 205 fi
pankso@61 206 gettext -e "Getting source from Hg...\n"
pankso@61 207 echo "URL: $url"
pankso@9 208 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
pankso@15 209 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
pankso@144 210 create_tarball ;;
pankso@9 211 git*)
pankso@61 212 url=${WGET_URL#git|}
pankso@61 213 gettext -e "Getting source from Git...\n"
pankso@61 214 echo "URL: $url"
pankso@64 215 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
pankso@63 216 if [ "$BRANCH" ]; then
pankso@146 217 echo "Git branch: $BRANCH"
pankso@64 218 cd $pkgsrc && git checkout $BRANCH && cd ..
pankso@63 219 fi
pankso@144 220 create_tarball ;;
pankso@144 221 cvs*)
pankso@144 222 url=${WGET_URL#cvs|}
pankso@144 223 mod=$PACKAGE
pankso@144 224 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
pankso@144 225 gettext -e "Getting source from CVS...\n"
pankso@144 226 echo "URL: $url"
pankso@146 227 [ "$CVS_MODULE" ] && echo "CVS module: $mod"
pankso@144 228 gettext "Cloning to: "; echo "$pwd/$mod"
pankso@144 229 cvs -d:$url co $mod && mv $mod $pkgsrc
pankso@144 230 create_tarball ;;
pankso@69 231 svn*|subversion*)
pankso@159 232 if $(echo "$WGET_URL" | fgrep -q "svn|"); then
pankso@146 233 url=${WGET_URL#svn|}
pankso@146 234 else
pankso@146 235 url=${WGET_URL#subversion|}
pankso@146 236 fi
pankso@146 237 gettext -e "Getting source from SVN...\n"
pankso@146 238 echo "URL: $url"
pankso@161 239 if [ "$BRANCH" ]; then
pankso@161 240 echo t | svn co $url -r $BRANCH $pkgsrc
pankso@161 241 else
pankso@161 242 echo t | svn co $url $pkgsrc
pankso@161 243 fi
pankso@146 244 create_tarball ;;
pankso@9 245 *)
pankso@9 246 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
pankso@9 247 tee -a $LOGS/$PACKAGE.log
pankso@9 248 exit 1 ;;
pankso@9 249 esac
pankso@1 250 }
pankso@1 251
pankso@9 252 # Extract source package.
pankso@1 253 extract_source() {
pankso@1 254 gettext "Extracting:"; echo " $TARBALL"
pankso@1 255 case "$TARBALL" in
pankso@120 256 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
pankso@120 257 *.tar.bz2|*.tbz) tar xjf $SRC/$TARBALL 2>/dev/null ;;
pankso@1 258 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
pankso@42 259 *.tar) tar xf $SRC/$TARBALL ;;
pankso@42 260 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
pankso@42 261 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
pankso@42 262 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
pankso@42 263 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
pankso@1 264 esac
pankso@1 265 }
pankso@1 266
pankso@9 267 # Display cooked package summary.
pankso@1 268 summary() {
pankso@1 269 cd $WOK/$pkg
pankso@1 270 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
pankso@1 271 fs=$(du -sh taz/* | awk '{print $1}')
pankso@44 272 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
pankso@44 273 files=$(cat taz/$pkg-*/files.list | wc -l)
pankso@18 274 cookdate=$(date "+%Y-%m-%d %H:%M")
pankso@101 275 sec=$time
pankso@104 276 div=$(($time / 60))
pankso@112 277 [ "$div" != 0 ] && min="~ ${div}m"
pankso@1 278 gettext "Summary for:"; echo " $PACKAGE $VERSION"
pankso@1 279 separator
pankso@67 280 [ "$prod" ] && echo "Produced : $prod"
pankso@1 281 cat << EOT
pankso@1 282 Packed : $fs
pankso@1 283 Compressed : $size
pankso@18 284 Files : $files
pankso@102 285 Cook time : ${sec}s $min
pankso@18 286 Cook date : $cookdate
pankso@1 287 $(separator)
pankso@1 288 EOT
pankso@1 289 }
pankso@1 290
paul@62 291 # Display debugging error info.
pankso@15 292 debug_info() {
pankso@17 293 echo -e "\nDebug information"
pankso@15 294 separator
pankso@48 295 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
pankso@76 296 for error in \
pankso@77 297 ERROR "No package" "cp: can't" "can't open" "can't cd" \
pankso@76 298 "error:" "fatal error:"
pankso@34 299 do
pankso@34 300 fgrep "$error" $LOGS/$pkg.log
pankso@34 301 done
pankso@15 302 separator && echo ""
pankso@15 303 }
pankso@15 304
pankso@1 305 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
pankso@1 306 # so some packages need to copy these files with the receipt and genpkg_rules.
pankso@1 307 copy_generic_files()
pankso@1 308 {
pankso@1 309 # $LOCALE is set in cook.conf
pankso@1 310 if [ "$LOCALE" ]; then
pankso@1 311 if [ -d "$_pkg/usr/share/locale" ]; then
pankso@1 312 mkdir -p $fs/usr/share/locale
pankso@1 313 for i in $LOCALE
pankso@1 314 do
pankso@1 315 if [ -d "$_pkg/usr/share/locale/$i" ]; then
pankso@1 316 cp -a $_pkg/usr/share/locale/$i $fs/usr/share/locale
pankso@1 317 fi
pankso@1 318 done
pankso@1 319 fi
pankso@1 320 fi
pankso@1 321
pankso@1 322 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
pankso@1 323 if [ "$GENERIC_PIXMAPS" != "no" ]; then
pankso@1 324 if [ -d "$_pkg/usr/share/pixmaps" ]; then
pankso@1 325 mkdir -p $fs/usr/share/pixmaps
pankso@1 326 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.png \
pankso@1 327 $fs/usr/share/pixmaps 2>/dev/null
pankso@1 328 cp -a $_pkg/usr/share/pixmaps/$PACKAGE.xpm \
pankso@1 329 $fs/usr/share/pixmaps 2>/dev/null
pankso@1 330 fi
pankso@1 331
pankso@1 332 # Custom or homemade PNG pixmap can be in stuff.
pankso@1 333 if [ -f "$stuff/$PACKAGE.png" ]; then
pankso@1 334 mkdir -p $fs/usr/share/pixmaps
pankso@1 335 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
pankso@1 336 fi
pankso@1 337 fi
pankso@1 338
pankso@1 339 # Desktop entry (.desktop).
pankso@1 340 if [ -d "$_pkg/usr/share/applications" ]; then
pankso@1 341 cp -a $_pkg/usr/share/applications $fs/usr/share
pankso@1 342 fi
pankso@1 343
pankso@1 344 # Homemade desktop file(s) can be in stuff.
pankso@1 345 if [ -d "$stuff/applications" ]; then
pankso@1 346 mkdir -p $fs/usr/share
pankso@1 347 cp -a $stuff/applications $fs/usr/share
pankso@1 348 fi
pankso@1 349 if [ -f "$stuff/$PACKAGE.desktop" ]; then
pankso@1 350 mkdir -p $fs/usr/share/applications
pankso@1 351 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
pankso@1 352 fi
pankso@1 353 }
pankso@1 354
pankso@67 355 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
pankso@68 356 # as removing uneeded files like in Python packages.
pankso@1 357 strip_package()
pankso@1 358 {
pankso@67 359 gettext "Executing strip on all files..."
pankso@1 360 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
pankso@1 361 do
pankso@1 362 if [ -d "$dir" ]; then
pankso@1 363 find $dir -type f -exec strip -s '{}' 2>/dev/null \;
pankso@1 364 fi
pankso@1 365 done
pankso@1 366 find $fs -name "*.so*" -exec strip -s '{}' 2>/dev/null \;
pankso@1 367 find $fs -name "*.a" -exec strip --strip-debug '{}' 2>/dev/null \;
pankso@1 368 status
pankso@67 369
pankso@117 370 # Remove Python .pyc and .pyo from packages.
pankso@150 371 if echo "$PACKAGE $DEPENDS" | fgrep -q "python"; then
pankso@68 372 gettext "Removing Python compiled files..."
pankso@67 373 find $fs -type f -name "*.pyc" -delete 2>/dev/null
pankso@67 374 find $fs -type f -name "*.pyo" -delete 2>/dev/null
pankso@117 375 status
pankso@117 376 fi
pankso@117 377
pankso@117 378 # Remove Perl perllocal.pod and .packlist from packages.
pankso@117 379 if echo "$DEPENDS" | fgrep -q "perl"; then
pankso@117 380 gettext "Removing Perl compiled files..."
pankso@67 381 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
pankso@67 382 find $fs -type f -name ".packlist" -delete 2>/dev/null
pankso@67 383 status
pankso@67 384 fi
pankso@1 385 }
pankso@1 386
pankso@8 387 # Remove installed deps.
pankso@8 388 remove_deps() {
pankso@8 389 # Now remove installed build deps.
pankso@113 390 diff="$CACHE/installed.cook.diff"
pankso@113 391 if [ -s "$CACHE/installed.cook.diff" ]; then
pankso@113 392 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
pankso@113 393 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@8 394 gettext "Build dependencies to remove:"; echo " $nb"
pankso@8 395 gettext "Removing:"
pankso@8 396 for dep in $deps
pankso@8 397 do
pankso@8 398 echo -n " $dep"
pankso@8 399 yes | tazpkg remove $dep >/dev/null
pankso@8 400 done
pankso@16 401 echo -e "\n"
pankso@113 402 # Keep the last diff for debug and info.
pankso@113 403 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
pankso@1 404 fi
pankso@1 405 }
pankso@1 406
pankso@1 407 # The main cook function.
pankso@1 408 cookit() {
pankso@11 409 echo "Cook: $PACKAGE $VERSION"
pankso@9 410 separator
pankso@1 411 set_paths
pankso@9 412 [ "$QA" ] && receipt_quality
pankso@44 413 cd $pkgdir
pankso@33 414 rm -rf install taz source
pankso@1 415
pankso@1 416 # Disable -pipe if less than 512Mb free RAM.
pankso@1 417 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
pankso@1 418 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
pankso@1 419 gettext -e "Disabling -pipe compile flag: $free RAM\n"
pankso@1 420 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
pankso@47 421 CXXFLAGS="${CXXFLAGS/-pipe}" && \
pankso@47 422 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
pankso@1 423 fi
pankso@1 424 unset free
pankso@1 425
pankso@1 426 # Export flags and path to be used by make
pankso@44 427 DESTDIR=$pkgdir/install
pankso@1 428 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS BUILD_HOST CONFIG_SITE
pankso@1 429 local LC_ALL=POSIX LANG=POSIX
pankso@1 430
pankso@126 431 # Check for build deps and handle implicit depends of *-dev packages
pankso@126 432 # (ex: libusb-dev :: libusb).
pankso@1 433 cd $INSTALLED && ls -1 > $CACHE/installed.list
pankso@1 434 [ "$DEPENDS" ] && gettext -e "Checking build dependencies...\n"
pankso@1 435 for dep in $BUILD_DEPENDS
pankso@1 436 do
pankso@126 437 implicit=${dep%-dev}
pankso@131 438 for i in $dep $implicit
pankso@126 439 do
pankso@131 440 if [ ! -f "$INSTALLED/$i/receipt" ]; then
pankso@126 441 # Try local package first.
pankso@131 442 vers=$(grep ^VERSION $WOK/$i/receipt | cut -d '"' -f 2)
pankso@131 443 if [ -f "$PKGS/$i-$vers.tazpkg" ]; then
pankso@131 444 gettext "Installing dep (pkg/local):"; echo " $i"
pankso@131 445 cd $PKGS && tazpkg install $i-$vers.tazpkg >/dev/null
pankso@126 446 else
pankso@131 447 gettext "Installing dep (web/cache):"; echo " $i"
pankso@131 448 tazpkg get-install $i >/dev/null
pankso@126 449 fi
pankso@1 450 fi
pankso@126 451 done
pankso@1 452 done
pankso@128 453 cd $INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
pankso@8 454
paul@62 455 # If a cook failed deps are not removed since we exit 1.
pankso@113 456 [ ! -s "installed.cook.diff" ] && \
pankso@141 457 busybox diff installed.list installed.cook > installed.cook.diff
pankso@113 458 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
pankso@1 459
pankso@1 460 # Get source tarball and make sure we have source dir named:
paul@62 461 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
paul@62 462 # tarball if it exists.
pankso@1 463 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
pankso@1 464 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
pankso@10 465 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
pankso@1 466 else
pankso@1 467 get_source || exit 1
pankso@1 468 fi
pankso@1 469 fi
pankso@9 470 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
pankso@1 471 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
pankso@1 472 extract_source || exit 1
paul@62 473 # Some archives are not well done and don't extract to one dir (ex lzma).
pankso@57 474 files=$(ls | wc -l)
pankso@57 475 [ "$files" == 1 ] && mv * ../$PACKAGE-$VERSION
pankso@57 476 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
pankso@57 477 mv * ../$PACKAGE-$VERSION
pankso@1 478 cd .. && rm -rf tmp
pankso@1 479 fi
pankso@1 480
pankso@9 481 # Execute receipt rules.
pankso@44 482 if grep -q ^compile_rules $receipt; then
pankso@1 483 gettext -e "Executing: compile_rules\n"
pankso@55 484 [ -d "$src" ] && cd $src
pankso@97 485 compile_rules $@ || exit 1
pankso@10 486 # Stay compatible with _pkg
pankso@55 487 [ -d "$src/_pkg" ] && mv $src/_pkg $install
pankso@9 488 # QA: compile_rules success so valid.
pankso@9 489 mkdir -p $install
pankso@9 490 else
pankso@9 491 # QA: No compile_rules so no error, valid.
pankso@9 492 mkdir -p $install
pankso@1 493 fi
pankso@1 494 separator && echo ""
pankso@1 495 }
pankso@1 496
pankso@1 497 # Cook quality assurance.
pankso@1 498 cookit_quality() {
pankso@9 499 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
pankso@15 500 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
pankso@9 501 fi
pankso@9 502 # ERROR can be echoed any time in cookit()
pankso@33 503 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@17 504 debug_info | tee -a $LOGS/$pkg.log
pankso@33 505 rm -f $command && exit 1
pankso@1 506 fi
pankso@1 507 }
pankso@1 508
pankso@16 509 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
paul@62 510 # but it doesn't handle EXTRAVERSION.
pankso@1 511 packit() {
pankso@1 512 set_paths
pankso@55 513 echo "Pack: $PACKAGE $VERSION"
pankso@1 514 separator
pankso@44 515 if grep -q ^genpkg_rules $receipt; then
pankso@16 516 gettext -e "Executing: genpkg_rules\n"
pankso@16 517 cd $pkgdir
pankso@98 518 mkdir -p $fs && genpkg_rules || echo -e \
pankso@98 519 "\nERROR: genpkg_rules failed\n" >> $LOGS/$pkg.log
pankso@16 520 fi
pankso@98 521
pankso@98 522 # First QA check to stop now if genpkg_rules failed.
pankso@98 523 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@98 524 exit 1
pankso@98 525 fi
pankso@98 526
pankso@44 527 cd $taz
pankso@1 528 for file in receipt description.txt
pankso@1 529 do
pankso@1 530 [ ! -f "../$file" ] && continue
pankso@1 531 gettext "Copying"; echo -n " $file..."
pankso@1 532 cp -f ../$file $pack && chown 0.0 $pack/$file && status
pankso@1 533 done
pankso@119 534 copy_generic_files
pankso@16 535
paul@62 536 # Create files.list with redirecting find output.
pankso@16 537 gettext "Creating the list of files..." && cd $fs
pankso@16 538 find . -type f -print > ../files.list
pankso@16 539 find . -type l -print >> ../files.list
pankso@16 540 cd .. && sed -i s/'^.'/''/ files.list
pankso@16 541 status
pankso@43 542
pankso@119 543 # Strip and stuff files.
pankso@43 544 strip_package
pankso@43 545
pankso@43 546 # Md5sum of files.
pankso@16 547 gettext "Creating md5sum of files..."
pankso@16 548 while read file; do
pankso@16 549 [ -L "fs$file" ] && continue
pankso@16 550 [ -f "fs$file" ] || continue
pankso@16 551 case "$file" in
pankso@16 552 /lib/modules/*/modules.*|*.pyc) continue;;
pankso@16 553 esac
pankso@16 554 md5sum "fs$file" | sed 's/ fs/ /'
pankso@16 555 done < files.list > md5sum
pankso@16 556 status
pankso@16 557 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
pankso@16 558 description.txt 2> /dev/null | awk \
pankso@16 559 '{ sz=$1 } END { print sz }')
pankso@16 560
pankso@16 561 # Build cpio archives.
pankso@16 562 gettext "Compressing the fs... "
pankso@16 563 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
pankso@16 564 rm -rf fs
pankso@16 565 status
pankso@16 566 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
pankso@16 567 md5sum description.txt 2> /dev/null | awk \
pankso@16 568 '{ sz=$1 } END { print sz }')
pankso@16 569 gettext "Updating receipt sizes..."
pankso@16 570 sed -i s/^PACKED_SIZE.*$// receipt
pankso@16 571 sed -i s/^UNPACKED_SIZE.*$// receipt
pankso@16 572 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
pankso@16 573 status
pankso@16 574
pankso@16 575 # Set extra version.
pankso@16 576 if [ "$EXTRAVERSION" ]; then
pankso@16 577 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
pankso@16 578 sed -i s/^EXTRAVERSION.*$// receipt
pankso@16 579 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
pankso@16 580 status
pankso@16 581 fi
pankso@16 582
pankso@16 583 # Compress.
pankso@16 584 gettext "Creating full cpio archive... "
pankso@16 585 find . -print | cpio -o -H newc --quiet > \
pankso@16 586 ../$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg
pankso@16 587 status
pankso@16 588 gettext "Restoring original package tree... "
pankso@16 589 unlzma -c fs.cpio.lzma | cpio -idm --quiet
pankso@16 590 status
pankso@16 591 rm fs.cpio.lzma && cd ..
pankso@43 592
pankso@43 593 # QA and give info.
pankso@43 594 tazpkg=$(ls *.tazpkg)
pankso@43 595 packit_quality
pankso@43 596 separator && gettext "Package:"; echo -e " $tazpkg\n"
pankso@1 597 }
pankso@1 598
paul@62 599 # Verify package quality and consistency.
pankso@8 600 packit_quality() {
pankso@157 601 #gettext "QA: Checking for broken link..."
pankso@157 602 #link=$(find $fs/usr -type l -follow)
pankso@157 603 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
pankso@157 604 #status
pankso@142 605
pankso@142 606 # Exit if any error found in log file.
pankso@33 607 if fgrep -q ERROR: $LOGS/$pkg.log; then
pankso@32 608 rm -f $command && exit 1
pankso@8 609 fi
pankso@142 610
pankso@44 611 gettext "QA: Checking for empty package..."
pankso@45 612 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
pankso@45 613 if [ "$files" -lt 0 ] && [ "$CATEGORY" != "meta" ]; then
pankso@44 614 echo -e "\nERROR: empty package"
pankso@32 615 rm -f $command && exit 1
pankso@8 616 else
pankso@134 617 # Ls sort by name so the first file is the one we want.
pankso@136 618 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
pankso@134 619 status
pankso@154 620 if [ -f "$old" ]; then
pankso@154 621 echo -n "Removing old: $(basename $old)"
pankso@135 622 rm -f $old && status
pankso@154 623 fi
pankso@134 624 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
pankso@11 625 sed -i /^${pkg}$/d $broken
pankso@8 626 fi
pankso@8 627 }
pankso@8 628
pankso@1 629 #
pankso@1 630 # Commands
pankso@1 631 #
pankso@1 632
pankso@1 633 case "$1" in
pankso@32 634 usage|help|-u|-h)
pankso@1 635 usage ;;
pankso@1 636 list-wok)
pankso@52 637 gettext -e "\nList of packages in:"; echo " $WOK"
pankso@1 638 separator
pankso@1 639 cd $WOK && ls -1
pankso@1 640 separator
pankso@1 641 echo -n "Packages: " && ls | wc -l
pankso@1 642 echo "" ;;
pankso@69 643 search)
pankso@69 644 # Just a simple search function, we dont need more actually.
pankso@69 645 query="$2"
pankso@69 646 gettext -e "\nSearch results for:"; echo " $query"
pankso@69 647 separator
pankso@69 648 cd $WOK && ls -1 | grep "$query"
pankso@69 649 separator && echo "" ;;
pankso@1 650 setup)
pankso@1 651 # Setup a build environment
pankso@1 652 check_root
pankso@11 653 echo "Cook: setting up the environment" | log
pankso@1 654 gettext -e "\nSetting up your environment\n"
pankso@1 655 separator && cd $SLITAZ
pankso@52 656 init_db_files
pankso@1 657 gettext -e "Checking for packages to install...\n"
pankso@29 658 for pkg in $SETUP_PKGS
pankso@1 659 do
pankso@52 660 [ ! -f "$INSTALLED/$pkg/receipt" ] && tazpkg get-install $pkg
pankso@1 661 done
pankso@1 662
pankso@1 663 # Handle --options
pankso@1 664 case "$2" in
pankso@49 665 --wok|-w)
pankso@52 666 [ ! -f "$INSTALLED/mercurial/receipt" ] && \
pankso@52 667 tazpkg get-install mercurial
paul@62 668 [ -d "$WOK" ] && echo -e "A wok already exists.\n" && exit 1
pankso@1 669 hg clone $HG_URL ;;
pankso@1 670 esac
pankso@1 671
pankso@1 672 # SliTaz group and permissions
pankso@1 673 if ! grep -q ^slitaz /etc/group; then
pankso@1 674 gettext -e "Adding group: slitaz\n"
pankso@1 675 addgroup slitaz
pankso@1 676 fi
pankso@1 677 gettext -e "Setting permissions for slitaz group...\n"
pankso@1 678 chown -R root.slitaz $SLITAZ
pankso@1 679 chmod -R g+w $SLITAZ
pankso@1 680 separator
pankso@1 681 gettext -e "All done, ready to cook packages :-)\n\n" ;;
pankso@9 682 test)
pankso@9 683 # Test a cook environment.
pankso@13 684 echo "Cook test: testing the cook environment" | log
pankso@9 685 [ ! -d "$WOK" ] && exit 1
pankso@9 686 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
pankso@9 687 cook cooktest ;;
pankso@1 688 new)
pankso@1 689 # Create the package folder and an empty receipt.
pankso@1 690 pkg="$2"
pankso@1 691 [ "$pkg" ] || usage
pankso@1 692 echo ""
pankso@1 693 if [ -d "$WOK/$pkg" ]; then
paul@62 694 echo -n "$pkg " && gettext "package already exists."
pankso@1 695 echo -e "\n" && exit 1
pankso@1 696 fi
pankso@1 697 gettext "Creating"; echo -n " $WOK/$pkg"
pankso@1 698 mkdir $WOK/$pkg && cd $WOK/$pkg && status
pankso@1 699 gettext "Preparing the package receipt..."
pankso@1 700 cp $DATA/receipt .
pankso@1 701 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
pankso@1 702 status && echo "" ;;
pankso@1 703 list)
pankso@1 704 # Cook a list of packages (better use the Cooker since it will order
pankso@1 705 # packages before executing cook).
pankso@1 706 check_root
pankso@1 707 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
pankso@1 708 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
pankso@1 709 echo -e " $2\n" && exit 1
pankso@13 710 echo "Cook list starting: $2" | log
pankso@1 711 for pkg in $(cat $2)
pankso@1 712 do
pankso@1 713 cook $pkg || broken
pankso@1 714 done ;;
pankso@1 715 clean-wok)
pankso@1 716 check_root
pankso@1 717 gettext -e "\nCleaning all packages files..."
pankso@1 718 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
pankso@1 719 status && echo "" ;;
pankso@1 720 clean-src)
pankso@1 721 check_root
paul@62 722 gettext -e "\nCleaning all packages sources..."
pankso@1 723 rm -rf $WOK/*/source
pankso@1 724 status && echo "" ;;
pankso@1 725 pkglist)
paul@62 726 # Create suitable packages list for TazPKG and only for built packages.
pankso@1 727 [ "$2" ] && PKGS="$2"
pankso@1 728 [ ! -d "$PKGS" ] && \
paul@62 729 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1
pankso@133 730 echo "cook:pkglist" > $command
paul@62 731 echo "Cook pkglist: Creating all packages lists" | log
pankso@1 732 gettext -e "\nCreating lists for:"; echo " $PKGS"
pankso@1 733 separator
pankso@133 734 cd $PKGS
pankso@148 735 rm -f packages.* files.*
pankso@1 736 gettext -e "Creating: packages.list\n"
pankso@85 737 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
pankso@1 738 gettext -e "Creating: packages.md5\n"
pankso@1 739 md5sum *.tazpkg > $PKGS/packages.md5
pankso@1 740 gettext -e "Creating: packages.desc\n"
pankso@1 741 gettext -e "Creating: packages.equiv\n"
pankso@1 742 cd $WOK
pankso@1 743 for pkg in *
pankso@1 744 do
pankso@1 745 unset_receipt
pankso@1 746 . $pkg/receipt
paul@153 747 # packages.desc lets us search easily in DB
pankso@1 748 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 749 cat >> $PKGS/packages.desc << EOT
pankso@1 750 $PACKAGE | $VERSION$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
pankso@1 751 EOT
pankso@1 752 # Packages.equiv is used by tazpkg install to check depends.
pankso@1 753 for i in $PROVIDE; do
pankso@1 754 DEST=""
pankso@1 755 echo $i | fgrep -q : && DEST="${i#*:}:"
pankso@1 756 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
pankso@1 757 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
pankso@1 758 $PKGS/packages.equiv
pankso@1 759 else
pankso@1 760 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
pankso@1 761 fi
pankso@1 762 done
pankso@1 763 fi
pankso@1 764 done
pankso@155 765 cd $PKGS
pankso@155 766
paul@153 767 # packages.txt (redundancy list, all info is in pkgs desc).
pankso@148 768 touch packages.txt
pankso@148 769
pankso@1 770 # files.list.lzma
pankso@156 771 gettext -e "Creating: files.list.lzma\n"
pankso@148 772 touch files.list
pankso@148 773 lzma e files.list files.list.lzma
pankso@148 774
pankso@1 775 separator
pankso@1 776 nb=$(ls $PKGS/*.tazpkg | wc -l)
pankso@133 777 echo -e "Packages: $nb\n"
pankso@133 778 rm -f $command ;;
pankso@1 779 *)
pankso@1 780 # Just cook and generate a package.
pankso@1 781 check_root
pankso@1 782 time=$(date +%s)
pankso@1 783 pkg="$1"
pankso@1 784 [ -z "$pkg" ] && usage
pankso@44 785 receipt="$WOK/$pkg/receipt"
pankso@1 786 check_pkg_in_wok && echo ""
pankso@47 787
pankso@128 788 # Display and log info if cook process stopped.
pankso@128 789 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
pankso@128 790 tee -a $LOGS/$pkg.log' INT
pankso@128 791
pankso@47 792 # Skip blocked, 3 lines also for the Cooker.
pankso@151 793 if grep -q "^$pkg$" $blocked && [ "$2" != "--unblock" ]; then
pankso@47 794 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
pankso@47 795 fi
pankso@47 796
pankso@47 797 # Log and source receipt.
pankso@56 798 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
pankso@16 799 echo "cook:$pkg" > $command
pankso@1 800 unset inst
pankso@1 801 unset_receipt
pankso@44 802 . $receipt
pankso@1 803
pankso@1 804 # Handle --options
pankso@1 805 case "$2" in
pankso@1 806 --clean|-c)
pankso@49 807 gettext -e "Cleaning:"; echo -n " $pkg"
pankso@1 808 cd $WOK/$pkg && rm -rf install taz source
pankso@1 809 status && echo "" && exit 0 ;;
pankso@1 810 --install|-i)
pankso@1 811 inst='yes' ;;
pankso@49 812 --getsrc|-gs)
pankso@49 813 gettext "Getting source for:"; echo " $pkg"
pankso@45 814 separator && get_source
pankso@39 815 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
pankso@49 816 --block|-b)
pankso@49 817 gettext "Blocking:"; echo -n " $pkg"
pankso@49 818 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
pankso@49 819 status && echo "" && exit 0 ;;
pankso@49 820 --unblock|-ub)
pankso@49 821 gettext "Unblocking:"; echo -n " $pkg"
pankso@49 822 sed -i "/^${pkg}$/"d $blocked
pankso@49 823 status && echo "" && exit 0 ;;
pankso@1 824 esac
pankso@1 825
paul@62 826 # Check if wanted is built now so we have separate log files.
pankso@1 827 if [ "$WANTED" ] && [ ! -d "$WOK/$WANTED/install" ]; then
pankso@138 828 if ! grep -q "^$WANTED$" $broken; then
pankso@137 829 cook "$WANTED"
pankso@137 830 fi
pankso@1 831 fi
pankso@1 832
pankso@1 833 # Cook and pack or exit on error and log everything.
pankso@97 834 cookit $@ 2>&1 | tee $LOGS/$pkg.log
pankso@15 835 remove_deps | tee -a $LOGS/$pkg.log
pankso@1 836 cookit_quality
pankso@26 837 packit 2>&1 | tee -a $LOGS/$pkg.log
pankso@1 838 clean_log
pankso@33 839
pankso@33 840 # Exit if any error in packing.
pankso@33 841 if grep -q ^ERROR $LOGS/$pkg.log; then
pankso@33 842 debug_info | tee -a $LOGS/$pkg.log
pankso@33 843 rm -f $command && exit 1
pankso@33 844 fi
pankso@16 845
pankso@1 846 # Time and summary
pankso@1 847 time=$(($(date +%s) - $time))
pankso@1 848 summary | tee -a $LOGS/$pkg.log
pankso@50 849 echo ""
pankso@1 850
pankso@1 851 # Install package if requested
pankso@1 852 if [ "$inst" ]; then
pankso@1 853 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
pankso@1 854 cd $PKGS && tazpkg install \
pankso@1 855 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
pankso@1 856 else
paul@62 857 gettext -e "Unable to install package, build has failed.\n\n"
pankso@1 858 exit 1
pankso@1 859 fi
pankso@1 860 fi
pankso@9 861 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
pankso@17 862 # You want automation: use the Cooker Build Bot.
pankso@1 863 #[ -d "$WOK/$pkg-dev" ] && cook $pkg-dev
pankso@18 864 rm -f $command ;;
pankso@1 865 esac
pankso@1 866
pankso@1 867 exit 0